
enum SIZE {
    //% block="29*29"
    1,
    //% block="58*58"
    2
}

enum LINE { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62 }
enum LINE2 { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16 }
enum RX { 2, 3 }
enum TX { 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, A0, A1, A2, A3, A4, A5 }


//% color="#FF69B4" iconWidth=50 iconHeight=40
namespace zNFC {


    //% block="初始化NFC IIC方式地址0x24" blockType="command"
    export function inital(parameter: any, block: any) {
        //let width = parameter.WIDTH.code

        Generator.addInclude('nfc', '#include <DFRobot_ZNFC0231.h>');
        //Generator.addInclude('wire', '#include <Wire.h>');
        Generator.addObject(`nfc`, `DFRobot_PN532_IIC`, `nfc;`);
        Generator.addSetup(`nfc.begin`, `nfc.begin();`);

    }

    //% block="初始化NFC模块 使用硬串口方式" blockType="command"
    export function initalSerial(parameter: any, block: any) {
        //let width = parameter.WIDTH.code

        Generator.addInclude('nfc', '#include <DFRobot_ZNFC0231.h>');
        //Generator.addInclude('wire', '#include <Wire.h>');
        Generator.addObject(`nfc`, `DFRobot_PN532_UART`, `nfc;`);
        Generator.addSetup(`nfc.begin`, `nfc.begin(&Serial);`);

    }

    //% block="初始化NFC模块 使用软串口方式 Rx[Rx] Tx[Tx]" blockType="command"
    //% Rx.shadow="dropdown"   Rx.options="RX"     Rx.defl="RX.1"
    //% Tx.shadow="dropdown"   Tx.options="TX"     Tx.defl="TX.3"
    export function initalSoft(parameter: any, block: any) {
        //let width = parameter.WIDTH.code
        let rx = parameter.Rx.code;
        let tx = parameter.Tx.code;
        Generator.addInclude('nfc', '#include <DFRobot_ZNFC0231.h>');
        Generator.addObject(`nfc`, `DFRobot_PN532_UART`, `nfc;`);
        Generator.addObject(`SoftwareSerial`, `SoftwareSerial`, `softSerial(${rx},${tx});`);
        Generator.addSetup(`nfc.begin`, `nfc.begin(&softSerial);`);

    }



    //% block="向数据块：[B]写入：[S] "  blockType="command"
    //% S.shadow="normal"   S.defl="string"
    //% B.shadow="dropdown"   B.options="LINE"     B.defl="LINE.1"
    export function WriteString(parameter: any, block: any) {
        let b = parameter.B.code;
        let s = parameter.S.code;
        Generator.addCode(`nfc.writeString(${b},${s});`);
    }

    //% block="向数据块[B]第[S]个字节写入[R] "  blockType="command"
    //% S.shadow="dropdown"    S.options="LINE2" S.defl="LINE2.1"
    //% B.shadow="dropdown"   B.options="LINE"     B.defl="LINE.1"
    //% R.shadow="range"   R.params.min=0    R.params.max=255    R.defl=100
    export function Writeblock(parameter: any, block: any) {
        let b = parameter.B.code;
        let s = parameter.S.code;
        let r = parameter.R.code;
        Generator.addCode(`nfc.writeData(${b},${s},${r});`);
    }
    //% block="读取数据块[B]的所有十六进制数据（String）" blockType="reporter"
    //% B.shadow="dropdown"   B.options="LINE"     B.defl="LINE.1"
    export function readData(parameter: any, block: any) {
        let b = parameter.B.code;
        Generator.addCode(`nfc.readData(${b})`);
    }

    //% block="读取数据块[B]的所有字符串数据" blockType="reporter"
    //% B.shadow="dropdown"   B.options="LINE"     B.defl="LINE.1"
    export function readDataString(parameter: any, block: any) {
        let b = parameter.B.code;
        Generator.addCode(`nfc.readDataString(${b})`);
    }

    //% block="读取NFC模块UID(string)" blockType="reporter"
    export function readUID(parameter: any, block: any) {
        Generator.addCode(`nfc.readUid()`);
    }


    //% block="读取数据块[B]第[S]个字节(number) "  blockType="reporter"
    //% S.shadow="dropdown"    S.options="LINE2" S.defl="LINE2.1"
    //% B.shadow="dropdown"   B.options="LINE"     B.defl="LINE.1"

    export function readblock(parameter: any, block: any) {
        let b = parameter.B.code;
        let s = parameter.S.code;

        Generator.addCode(`nfc.readData(${b},${s})`);
    }

    //% block="检测到卡片UID[u]?" blockType="boolean"
    //% u.shadow="normal"  u.defl="a1b2c3d4"
    export function scanNFC(parameter: any, block: any) {
        let u = parameter.u.code;
        Generator.addCode(`nfc.scan(${u})`);
    }

    //% block="检测到卡片?" blockType="boolean"
    export function scan(parameter: any, block: any) {
        Generator.addCode(`nfc.scan()`);
    }

}
